#include "testlib.h"
#include <stdio.h>
#include <iostream>
#include <stdlib.h>
#include <string>
#include <string.h>
#include <vector>
#include <stack>
#include <queue>
#include <deque>
#include <set>
#include <map>
#include <assert.h>
#include <algorithm>
#include <iomanip>
#include <time.h>
#include <math.h>
#include <bitset>

#pragma comment(linker, "/STACK:256000000")

using namespace std;

typedef long long int ll;
typedef long double ld;

vector<string> to_add;
vector<pair<int, int>> ptr;

int main(int argc, char **argv)
{
	registerGen(argc, argv, 1);
	
	int sum_len = atoi(argv[1]);
	int cnt = atoi(argv[2]);
	int max_len = atoi(argv[3]);
	assert(max_len & 1);
	
	to_add.resize(1);
	ptr.push_back({0, 0});
	cin >> to_add[0];
	
	assert((int)to_add[0].size() <= sum_len);
	int cur_can = sum_len - (int)to_add[0].size();
	for (int i = 0; i < cnt; ++i)
	{
		int cur_len = rnd.next(0, min(max_len, cur_can));
		if (cur_len % 2 == 0) ++cur_len;
		if (cur_len > cur_can) continue;
		cur_can -= cur_len;

		string cur = string(cur_len, '0');
		for (int i = 1; i < cur_len; i += 2) cur[i] = '1';
		to_add.push_back(cur);
		ptr.push_back({(int)to_add.size() - 1, 0});
	}

	for (int i = 0; i < cur_can; ++i)
	{
		to_add.push_back("0");
		ptr.push_back({(int)to_add.size() - 1, 0});
	}
	
	string ans = "";
	while (!ptr.empty())
	{
		int now = rnd.next(0, (int)ptr.size() - 1);
		ans += to_add[ptr[now].first][ptr[now].second++];
		if (ptr[now].second == (int)to_add[ptr[now].first].size())
		{
			swap(ptr[now], ptr.back());
			ptr.pop_back();
		}
	}
	
	assert((int)ans.size() == sum_len);
	printf("%s\n", ans.c_str());

	return 0;
}



