#include <cassert>
#include <cinttypes>
#include <iostream>
#include <map>
#include <queue>
#include <set>
#include <sstream>
#include <string>
#include <unordered_map>
#include <utility>
#include <vector>
#include <string.h>
#include <algorithm>
#include <cmath>
#include <cstdio>

typedef int8_t i8;
typedef int16_t i16;
typedef uint8_t ui8;
typedef uint16_t ui16;
typedef uint32_t ui32;
typedef int32_t i32;
typedef uint64_t ui64;
typedef int64_t i64;

constexpr ui64 INF = 1e18;
char s[300001];

int main(void) {
    std::vector<std::vector<int>> ans;
    scanf("%s", s);
    int n = strlen(s);
    std::queue<int> q0, q1;
    for (int i = 0; i < n; ++i) {
        if (s[i] == '0') {
            int f = 0;
            if (!q1.empty()) {
                ans[q1.front()].push_back(i);
                f = 1;
            }
            if (!f) {
                ans.push_back({i});
                q0.push(ans.size() - 1);
            } else {
                q0.push(q1.front());
                q1.pop();
            }
        } else {
            int f = 0;
            if (!q0.empty()) {
                ans[q0.front()].push_back(i);
                f = 1;
            }
            if (!f) {
                printf("-1\n");
                return 0;
            }
            q1.push(q0.front());
            q0.pop();
        }
    }
    for (size_t i = 0; i < ans.size(); ++i) {
        if (s[ans[i].back()] == '1') {
            printf("-1\n");
            return 0;
        }
    }
    printf("%zu\n", ans.size());
    for (size_t i = 0; i < ans.size(); ++i) {
        printf("%zu ", ans[i].size());
        for (auto& el : ans[i]) {
            printf("%d ", el + 1);
        }
        printf("\n");
    }
    return 0;
}
