#include <stdio.h>
#include <iostream>
#include <stdlib.h>
#include <string>
#include <string.h>
#include <vector>
#include <stack>
#include <queue>
#include <deque>
#include <set>
#include <map>
#include <assert.h>
#include <algorithm>
#include <iomanip>
#include <time.h>
#include <math.h>
#include <bitset>

#pragma comment(linker, "/STACK:256000000")

using namespace std;

typedef long long int ll;
typedef long double ld;

const int INF = 1000 * 1000 * 1000 + 21;
const ll LLINF = (1ll << 60) + 5;
const int MOD = 1000 * 1000 * 1000 + 7;

const int MAX_N = 1000 * 1000 + 228;

int n;
char st[MAX_N];
vector<vector<int>> ans;

void no()
{
	printf("-1\n");
	exit(0);
}

bool solve(int sz)
{
	if (sz <= 0) return false;

	int ptr0 = sz - 1;
	int ptr1 = sz - 1;
	ans.clear();
	ans.resize(sz);
	
	for (int i = 0; i < n; ++i)
	{
		if (st[i] == '0')
		{
			ans[++ptr0 %= sz].push_back(i);
			if (ans[ptr0].size() > 1 && st[ans[ptr0].back()] == st[ans[ptr0][(int)ans[ptr0].size() - 2]]) return false;
		}
		else 
		{
			ans[++ptr1 %= sz].push_back(i);
			if (ans[ptr1].size() > 1 && st[ans[ptr1].back()] == st[ans[ptr1][(int)ans[ptr1].size() - 2]]) return false;
		}
	}
	
	for (int i = 0; i < sz; ++i)
	{
		if ((int)ans[i].size() % 2 == 0) return false;
		for (int j = 0; j < (int)ans[i].size(); ++j) if (st[ans[i][j]] - '0' != j % 2) return false;
	}

	printf("%d\n", (int)ans.size());
	for (int i = 0; i < (int)ans.size(); ++i)
	{
		printf("%d ", (int)ans[i].size());
		for (int j = 0; j < (int)ans[i].size(); ++j) printf("%d%c", ans[i][j] + 1, " \n"[j == (int)ans[i].size() - 1]);
	}

	exit(0);
	return true;
}

int main()
{
#ifdef CH_EGOR
	freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
#else
	//freopen("", "r", stdin);
	//freopen("", "w", stdout);
#endif

	scanf("%s", st);
	n = strlen(st);
	
	for (int i = 1; i <= n; ++i) solve(i);
	no();
	
	return 0;
}

