#include <algorithm>
#include <cstdio>
#include <vector>
#include <map>

using namespace std;

int main() {
  vector< vector<int> > ans;
  vector<int> zeros_ans;
  map<int, int> last_pair;
  int num_answers;
  char c = getchar();

  vector<int> zeros_stack;
  int i = 1;
  while(c == '0' || c == '1') {
    if (c == '0') {
      zeros_stack.push_back(i);
    } else {
      if (zeros_stack.empty()) {
        printf("-1\n");
        return 0;
      }
      int zeros_pos = zeros_stack.back();
      zeros_stack.pop_back();
      map<int,int>::iterator ub = last_pair.upper_bound(zeros_pos);
      if (ub == last_pair.begin()) {
        vector<int> tmp;
        tmp.push_back(zeros_pos);
        tmp.push_back(i);
        last_pair[zeros_pos] = ans.size();
        ans.push_back(tmp);
      } else {
        --ub;
        int seq = ub->second;
        ans[seq].push_back(zeros_pos);
        ans[seq].push_back(i);
        last_pair.erase(ub);
        last_pair[zeros_pos] = seq;
      }
    }
    c = getchar();
    ++i;       
  }
  
  for (int i = zeros_stack.size() - 1; i >= 0; --i) {
    map<int,int>::iterator ub = last_pair.upper_bound(zeros_stack[i]);
    if (ub == last_pair.begin()) {
      zeros_ans.push_back(zeros_stack[i]);
    } else {
      --ub;
      int seq = ub->second;
      ans[seq].push_back(zeros_stack[i]);
      last_pair.erase(ub);
    }
  }

  if (!last_pair.empty()) {
    printf("-1\n");
    return 0;
  }
  
  printf("%d\n", ans.size() + zeros_ans.size());
  for (int i = 0; i < ans.size(); ++i) {
    printf("%d ", ans[i].size());
    for (int j = 0; j < ans[i].size(); ++j) {
      printf("%d ", ans[i][j]);
    }
    printf("\n");
  }

  for (int i = 0 ; i < zeros_ans.size(); ++i) {
    printf("%d %d\n", 1, zeros_ans[i]);
  }
  return 0; 
}
