#include <algorithm>
#include <cassert>
#include <cmath>
#include <cstdlib>
#include <iomanip>
#include <iostream>
#include <map>
#include <set>
#include <string>
#include <unordered_map>
#include <unordered_set>
#include <utility>
#include <vector>

using namespace std;

using ll = long long;
using ull = unsigned long long;
using ldb = long double;

#define forn(i, x, n) for (int i = x; i < (int)(n); ++i)
#define forcin(a, n) for (int i = 0; i < n; cin >> a[i], ++i)
#define forb(i, x, n) for (int i = (int)(x); i >= n; --i)
#define mmax(a, b, c) max(a, max(b, c))
#define mmin(a, b, c) min(a, min(b, c))
#define pb push_back
#define mp make_pair
#define x1 kek
#define y1 lol

const int N = 100500 * 3;
const double eps = 1e-11;
const int mod = 1020421001;
const int inf = numeric_limits<int>::max();

vector<vector<int>> ans;
int cntUsed, cntPrev = -1;
bool used[N];
int cur;
//unordered_map<int, int> corr;

int main() {
    string s;
    cin >> s;
    int n = s.size();

    set<int> opened, closed;
//    vector<int> lastClosed;
    for (int i = 0; i < n; ++i) {
        if (s[i] == '0') {
            if (closed.empty()) {
                opened.insert(cur);
                ans.pb({});
                ans[cur++].pb(i);
            } else {
                int ind = *closed.begin();
                ans[ind].pb(i);
                opened.insert(ind);
                closed.erase(closed.begin());
//                lastClosed.pb(i);
//                corr[i] = ind;
            }
        } else {
            if (opened.empty()) {
                cout << -1 << '\n';
                return 0;
//                if (lastClosed.empty()) {
//                    cout << -1 << '\n';
//                    return 0;
//                }
//                int p = lastClosed.back();
//                lastClosed.pop_back();
//                closed.erase(closed.find(corr[p]));
//                ans[corr[p]].pop_back();
//                closed.insert(cur);
//                ans[cur].pb(p);
//                ans[cur++].pb(i);
            } else {
                int ind = *opened.begin();
                ans[ind].pb(i);
                opened.erase(opened.begin());
                closed.insert(ind);
            }
        }
    }

    if (!closed.empty()) {
        cout << -1 << '\n';
        return 0;
    }

    cout << ans.size() << '\n';
    for (auto res : ans) {
        cout << res.size() << " ";
        for (auto a : res) {
            cout << a + 1 << " ";
        }
        cout << '\n';
    }
}
