#include <algorithm>
#include <cmath>
#include <cstdio>
#include <cstring>
#include <deque>
#include <stack>
#include <iostream>
#include <map>
#include <random>
#include <set>
#include <stack>
#include <string>
#include <vector>
#include <unordered_map>
#include <unordered_set>
#include <utility>
 
using namespace std;

int main() {
    ios_base::sync_with_stdio(false);

    string s;
    cin >> s;
    int n = (int)s.size();
    vector<int> used(n, 0);
    set<int> zero, one;
    for (int i = 0; i < n; i++)
        (s[i] == '0' ? zero : one).insert(i);

    int cnt = 0;
    while (!zero.empty()) {
        cnt++;
        int pos = (*zero.begin());
        zero.erase(zero.begin());
        used[pos] = cnt;
        while (one.upper_bound(pos) != one.end()) {
            auto it = one.upper_bound(pos);
            pos = (*it);
            used[pos] = cnt;
            one.erase(it);
            if (zero.upper_bound(pos) == zero.end()) {
                cout << -1 << endl;
                return 0;
            }
            it = zero.upper_bound(pos);
            pos = (*it);
            used[pos] = cnt;
            zero.erase(it);
        }
    }

    if (!one.empty()) {
        cout << -1 << endl;
        return 0;
    }

    vector< vector<int> > ans(cnt);
    for (int i = 0; i < n; i++) {
        if (!used[i]) {
            cout << -1 << endl;
            return 0;
        }
        ans[used[i] - 1].push_back(i + 1);
    }

    cout << cnt << endl;
    for (auto& i : ans) {
        cout << i.size() << ' ';
        for (int j : i)
            cout << j << ' ';
        cout << endl;
    }

    return 0;
}
