#include <stdio.h>
#include <iostream>
#include <stdlib.h>
#include <string>
#include <string.h>
#include <vector>
#include <stack>
#include <queue>
#include <deque>
#include <set>
#include <map>
#include <assert.h>
#include <algorithm>
#include <iomanip>
#include <time.h>
#include <math.h>
#include <bitset>

#pragma comment(linker, "/STACK:256000000")

using namespace std;

typedef long long int ll;
typedef long double ld;

const int INF = 1000 * 1000 * 1000 + 21;
const ll LLINF = (1ll << 60) + 5;
const int MOD = 1000 * 1000 * 1000 + 7;

const int MAX_N = 1000 * 1000 + 228;

int n;
char st[MAX_N];
vector<vector<int>> ans;
vector<int> zero;
vector<int> one;

void no()
{
	printf("-1\n");
	exit(0);
}

int main()
{
#ifdef CH_EGOR
	freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
#else
	//freopen("", "r", stdin);
	//freopen("", "w", stdout);
#endif
	
	cin >> st;
	n = strlen(st);

	for (int i = 0; i < n; ++i)
	{
		if (st[i] == '0')
		{
			if (!one.empty())
			{
				ans[one.back()].push_back(i);
				zero.push_back(one.back());
				one.pop_back();
			}
			else
			{
				zero.push_back((int)ans.size());
				ans.push_back(vector<int>(1, i));
			}
		}
		else
		{
			if (zero.empty()) no();
			ans[zero.back()].push_back(i);
			one.push_back(zero.back());
			zero.pop_back();
		}
	}

	if (!one.empty()) no();

	cout << ans.size() << endl;
	for (int i = 0; i < (int)ans.size(); ++i)
	{
		cout << ans[i].size() << " ";
		for (int j = 0; j < (int)ans[i].size(); ++j) cout << ans[i][j] + 1 << " ";
		cout << endl;
	}

	return 0;
}


